
package login;

import com.fxcore2.O2GSession;
import com.fxcore2.O2GTransport;
import java.util.Scanner;

public class Main {
    public static String strSessionID = "";
    public static String strPin = "";
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws InterruptedException {
        // TODO code application logic here
        Scanner sc = new Scanner(System.in);
        if (args.length < 4)
    {
            System.out.println("Not Enough Parameters!");
            System.out.println("USAGE: [user ID] [password] [URL] [connection] [session ID (if needed)] [pin (if needed)]");
            System.out.println("\nPress any key to close the program");
            sc.next();
            return;
    }

    String strUserID = args[0];
    String strPassword = args[1];
    String strURL = args[2];
    String strConnection = args[3];

    if (args.length > 4)
    {
            strSessionID = args[4];
    }

    if (args.length > 5)
    {
            strPin = args[5];
    }

        try
    {
            O2GSession session = O2GTransport.createSession();
            mySessionStatusListener statusListener = new mySessionStatusListener(session);
            session.subscribeSessionStatus(statusListener);
            session.login(strUserID, strPassword, strURL, strConnection);
            while (!statusListener.getConnected() && !statusListener.getError())
            {
                    Thread.sleep(50);
            }
            if (!statusListener.getError())
            {
                    session.logout();
                    while (!statusListener.getDisconnected())
                    {
                            Thread.sleep(50);
                    }
            }
            session.unsubscribeSessionStatus(statusListener);
            System.out.println("Done!");
            sc.next();
            session.dispose();
        }
        catch (RuntimeException e)
        {
          System.out.println ("Exception: " + e.toString());
        }
    }

}
