package setsubscription;

import java.util.concurrent.ConcurrentLinkedQueue;

import com.fxcore2.IO2GResponseListener;
import com.fxcore2.O2GResponse;

public class ResponseListener implements IO2GResponseListener{

    private SimpleLog mSimpleLog;
    private ConcurrentLinkedQueue<O2GResponse> mResponseQueue;
    private EventPipe mEventPipe;

    public ResponseListener(SimpleLog simpleLog, ConcurrentLinkedQueue<O2GResponse> responseQueue, EventPipe eventPipe) {
        mSimpleLog = simpleLog;
        mResponseQueue = responseQueue;
        mEventPipe = eventPipe;
    }

    @Override
    public void onRequestCompleted(String sRequestID, O2GResponse response) {
        boolean add = mResponseQueue.add(response);
        if (sRequestID.equals(Main.sSetSubscriptionStatusRequestID))
            System.out.println("SetSubsriptionStatus (" + Main.sStatus + " for " + Main.sInstrument + ") successful");
        mEventPipe.putEvent(EventType.RESPONSE);
    }

    @Override
    public void onRequestFailed(String sRequestID, String sError) {
        if (sRequestID.equals(Main.sSetSubscriptionStatusRequestID)) {
            System.out.println("SetSubsriptionStatus (" + Main.sStatus + " for " + Main.sInstrument + ") failed");
            System.out.println("Error: " + sError);
        }
        mSimpleLog.log("Request fails requestID=" + sRequestID + "; error=" + sError);
    }

    @Override
    public void onTablesUpdates(O2GResponse response) {
    }
}
